/*
+---+---+---+---+
| A | I | O | S |
+---+---+---+---+
AMX MOD X Script 
Visit www.amxmodx.org 
[AIOS] 
All.In.One.Slap 
Version v10.0 
 Copyright 2004 - 2005 
Nicholas Glistak

Info On Plugin :
================
Made so you can slap/slay anyone any team as much times as you want.
The amount of slaps and the damage per slap each both controlled by cvars.

Commands :
==========
- amx_aios       :  < Usage: amx_aios | 1 = Slap All | 2 = Slap CTs | 3 = Slap Ts >
- amx_aios2      :  < Usage: amx_aios2 | 1 = Slay All | 2 = Slay CTs | 3 = Slay Ts >
- amx_tslap      :  < name or userid >
- amx_tslay      :  < name or userid > < Effect 1|2|3 >
- amx_slapdmg    :  < Damager per Slap >
- amx_slapnum    :  < Amount of slaps >
- amx_aiosmenu   :  < Displays AIOs menu >

- Press 'p' in-game to open the AIOS Menu
- Press '[' in-game to Slap the player you are looking at
- Press '[' in-game to Slay the player you are looking at

Client Commands :
=================
- say /slapme : No admin access required < Client slaps thenselves >
- Type mSlap in console. Usage : mslap |Number of Slaps|.

Install :
=========
- Place .amxx file into your plugins folder. 
- Open plugins.ini, add line containing 
- AIOS.amxx 
- Place tslap.wav into your sound/misc folder.

History :
=========
ChangeLog 
- 1.0 First Release for AMX MOD X 0.16 
- 1.1 Added Menu 
- Added Menu Command 
- amx_aiosmenu <Displays AIOS Menu> 
             
- 2.0 Added Command Functions 
- amx_slayall 
- amx_slayct 
- amx_slayt   
      
- v3.0 
- AMX MOD X .20   
- Added /slapme command - idea from Tweeks slapme plugin 
- Fixed AIOS Menu

- v4.0
- AMX MOD X 1.0 Final
- Recoded
- Removed long command list

- v5.0
- Added Point Slap command
- Added Point slay command

- v6.0
- Added Effects
- Added Tslay
- Tested plugin : Found no problems
- Done.

- v7.0
- Directory Change for tslap.wav to sound/misc/tslap.wav
- /slapme slap reset problem fixed

- v8.0
- Bug fixes :
	- Sprites not showing
	- Fixed spelling mistakes
- Changed Explosion Sprite

- v9.0
- Bug fixes :
	- Fixed HUD names not showing
- Changed MAX number of slaps from 100 to 1000

- 10.0
- Useless function removed
- Cleaned code
- Removed useless code
- Fixed Menu Functions not working
- FIXED all known bugs
- DONE !!!
*/
//--------------------------------------------------------------------------------------------------------------------//
#include <amxmodx> 
#include <amxmisc>
//---------------------------
// Name, Version, Author
new pName[] = "AIOS Slap/Slay"
new pVersion[] = "v1.0.0"
new pAuthor[] = "Nicholas Glistak"
// Lights, Explosions, Blood
new bloodspray
new blooddrip
new lightning
new smoke
new explode
// Gibs, Body Parts
new gib_skull
new gib_legbone
new gib_lung
new gib_b_gib
new gib_b_bone
// SlapMe
new g_slaps[33] = 0
new g_msSlaps[33] = 0
//---------------------------
public plugin_init ( ) 
{
	register_plugin ( pName, pVersion, pAuthor )
	
	register_concmd ( "amx_aios", "AIOS", ADMIN_SLAY, "< Usage: amx_aios | 1 = Slap All | 2 = Slap CTs | 3 = Slap Ts > [AIOS]" )
	register_concmd ( "amx_aios2", "AIOS2", ADMIN_SLAY, "< Usage: amx_aios2 | 1 = Slay All | 2 = Slay CTs | 3 = Slay Ts > [AIOS]" )
	register_concmd ( "amx_tslap", "Tslap", ADMIN_SLAY, "< name or userid > [AIOS]" )
	register_concmd ( "amx_tslay", "Tslay", ADMIN_SLAY, "< name or userid > < Effect 1|2|3 > [AIOS]" )
	register_concmd ( "amx_slapdmg", "SlapDmg", ADMIN_CVAR, "< Damage Per Slap > [Sets the damage per slap] [AIOS]" )
	register_concmd ( "amx_slapnum", "SlapNum", ADMIN_CVAR, "< Number of Slaps > [Sets the number of slaps] [AIOS]" )
	register_concmd ( "amx_msSlaps", "msSlapToggle", ADMIN_CVAR, " < amx_msSlaps | 1 = ON | 2 = OFF | > [AIOS]" )
	register_concmd ( "amx_msLimit", "msLimitToggle", ADMIN_CVAR, " < amx_msLimit < Number of msSlaps > [AIOS] " )
	register_concmd ( "amx_aiosmenu", "showMenu", ADMIN_SLAY, "< Displays AIOS Slap Menu > [AIOS]" )
	
	register_clcmd ( "say /slapme", "SlapMe", -1, "< Slaps Yourself >" )
	register_clcmd ( "mSlap", "msSlaps", -0, " < Usage : mslap |Number of Slaps| [AIOS] " )
	register_clcmd ( "say /aios", "AiosMotdCall", ADMIN_SLAY, "< Displays Aios Help > [AIOS]" )
	register_clcmd ( "/aiosmenu", "showMenu", ADMIN_SLAY, "< Displays AIOS Slap Menu > [AIOS]" )
	register_clcmd ( "/slap", "Point_Slap", ADMIN_SLAY, "< Slaps whoever you are pointing at > [AIOS]" )
	register_clcmd ( "/slay", "Point_Slay", ADMIN_SLAY, "< Slays whoever you are pointing at > [AIOS]" ) 
	
   	register_cvar ( "aios_slapdmg", "1" )
	register_cvar ( "aios_slapnum", "50" )
	register_cvar ( "aios_slaps", "1" )
	register_cvar ( "aios_sLimit", "3" )
	register_cvar ( "aios_msSlaps", "1" )
	register_cvar ( "aios_msLimit", "3" )
	register_cvar ( "aios_credits", "0" )
	register_cvar ( "aios_bloodeffect", "1" )
	
	register_event ( "ResetHUD", "ResetSlaps", "b" )
	register_menucmd (register_menuid ( "\r[\wA\yI\rO\wS\y] \yMenu: NG^nAll.In.One.Slap Menu^nBy \rN\wi\yk\ro \yGlistak^n") ,(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6), "MenuCommand" )
	set_task ( 0.1, "ResetSlaps" )
	
	
	for ( new i = 0; i < 33; i++ )
	{
		g_msSlaps[i] = 0
		g_slaps[i] = 0
	}
}

public plugin_precache ( ) 
{
	precache_sound ( "ambience/thunder_clap.wav" ) 
	precache_sound ( "debris/zap6.wav" )
	precache_sound ( "weapons/explode3.wav" )
	 
	if ( file_exists ( "sound/misc/tslap.wav" ) ) 
	{
		precache_sound ( "sound/misc/tslap.wav" )
		console_print ( 0, "[AIOS] Tslap.wav found in cstrike/sound/misc folder." )

	} 
	else 
	{
		console_print ( 0, "[AIOS] * WARNING * : Tslap.wav was not found in the proper directory!" )
		console_print ( 0, "[AIOS] * FIX * : Please put Tslap.wav into you cstrike/sound/misc folder." )
		
	}
	
	bloodspray = precache_model ( "sprites/bloodspray.spr" )
   	blooddrip = precache_model ( "sprites/blood.spr" )
   	lightning = precache_model ( "sprites/lgtning.spr" )
   	smoke = precache_model ( "sprites/steam1.spr" )
   	explode = precache_model ( "sprites/explode1.spr" )
   	
	gib_skull = precache_model ( "models/gib_skull.mdl" )
	gib_legbone = precache_model ( "models/gib_legbone.mdl" )
	gib_lung = precache_model ( "models/gib_lung.mdl" )
	gib_b_gib = precache_model ( "models/gib_b_gib.mdl" )
	gib_b_bone = precache_model( "models/gib_b_bone.mdl" )
}

public  aios_intro ( id ) 
{
	console_print ( 0, "[AIOS] All.In.One.Slap by Niko Glistak." )
	console_print ( 0, "Visit www.amxmodx.org" )
	client_print ( 0, print_chat, "[AIOS] All.In.One.Slap by Niko Glistak." )
	client_print ( 0, print_chat, "Visit www.amxmodx.org" )
}

public AdminBinds ( id, level, cid )
{
	if ( cmd_access ( id, level, cid, 1 ) )
	{
		console_cmd ( id, "bind [ /slap" )
		console_cmd ( id, "bind ] /slay" )
		console_cmd ( id, "bind p amx_aiosmenu" )
		
		console_print ( id, "----------[AIOS]----------" )
		console_print ( id, "Press 'p' in-game to open the AIOS Menu." )
		console_print ( id, "Press '[' in-game to Slap the player you are pointing at." )
		console_print ( id, "Press ']' in-game to Slay the player you are pointing at." )
		console_print ( id, "----------[AIOS]----------" )
	}
}
 
public client_connect( id ) 
{
	g_msSlaps[id] = 0
	g_slaps[id] = 0
}

public client_putinserver ( id )
{
	if ( get_cvar_num ( "aios_credits" ) == 1 ) {

		set_task ( 20.0, "aios_intro" )
	}
	
	set_task ( 10.0, "AdminBinds", id )
	
	return PLUGIN_CONTINUE
}

public ResetSlaps ( id ) 
{
	for ( new i = 0; i < 33; i++ )
	{
		g_msSlaps[i] = 0
		g_slaps[i] = 0
	}
	
	console_print ( 0, "[AIOS] All.In.One.Slap by Niko Glistak." )
	console_print ( 0, "Visit www.amxmodx.org" )
}

public SlapAll ( ) 
{
	new slapdmg = get_cvar_num ( "aios_slapdmg" )
	new Players[32], iTotalPlayers
	get_players( Players, iTotalPlayers, "a" )
	
	for ( new i = 0; i < iTotalPlayers; i++ ) 
   	{ 
        	new id = Players[i]
        	user_slap ( id, slapdmg )
   	} 
} 

public SlapCTs ( ) 
{  
	new slapdmg = get_cvar_num ( "aios_slapdmg" )
	new team[32], iTotalCTs
	get_players( team,iTotalCTs, "e", "CT" )

	for ( new i = 0; i < iTotalCTs; i++ ) 
	{		
        	new id = team[i]
        	user_slap( id, slapdmg )
	}
}

public SlapTs ( ) 
{    
	new slapdmg = get_cvar_num ( "aios_slapdmg" )
	new team[32], iTotalTs
	get_players( team, iTotalTs, "e", "TERRORIST" )
	
	for ( new i = 0; i < iTotalTs; i++ ) 
	{		
		new id = team[i]
		user_slap( id ,slapdmg )
   	} 
}

public Tslap( id, level, cid ) 
{
	if ( !cmd_access (id, level, cid, 2) ) {
		return PLUGIN_HANDLED
	}
	
	new admin[32], victim[32]
	get_user_name( id, admin, 31 )
	new arg[32]
	read_argv( 1, arg, 31 )
	new player = cmd_target ( id, arg, 5 ) 
	if ( !player ) return PLUGIN_HANDLED
	
	new ids[2] 
	ids[0] = player 
	get_user_name( player, victim, 31 ) 
	
	new slapnum = get_cvar_num ( "aios_slapnum" )
	new r = random ( 256 )
	new g = random ( 256 )
	new b = random ( 256 )

	switch ( get_cvar_num ( "amx_show_activity" ) ) 
	{
		case 2:
		{
			client_print ( 0, print_chat, "[AIOS] Admin %s: Tslapped %s %d times(s).", admin, victim, slapnum )
			set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
			show_hudmessage( 0, "[AIOS] Admin %s: Tslapped %s %d times(s).", admin, victim, slapnum )
			client_cmd( 0, "spk misc/tslap.wav" )
		}
		case 1:
		{
			client_print( 0, print_chat, "[AIOS] Admin : Tslapped %s %d times(s).", victim, slapnum )
			set_hudmessage( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
			show_hudmessage( 0, "[AIOS] Admin : Tslapped %s %d times(s).", victim, slapnum )
			client_cmd( id, "spk misc/tslap.wav" )
		}
	}

	set_task( 0.1, "tslap_target", 0, ids, 2, "a", slapnum ) 
	return PLUGIN_HANDLED
}

public tslap_target( ids[] ) 
{

	new id = ids[0]
	if ( get_cvar_num ( "aios_bloodeffect" ) == 1 ) 
	{
		new origin[3]
		get_user_origin( id, origin )
		bloodeffects ( origin )
	}	
	
	new dmg = get_cvar_num ( "aios_slapdmg" )
	new health = get_user_health ( id )
	if ( health > 1 ) 
	{
		user_slap ( id, dmg )
	} 
	else if ( health == 1 ) 
	{
		user_slap ( id, 0 )
	}
	return PLUGIN_HANDLED
} 

public Tslay( id, level, cid ) 
{
	if ( !cmd_access ( id, level, cid, 2 ) ) {
		return PLUGIN_HANDLED
	}
	
	new admin[32], victim[32]
	get_user_name ( id, admin, 31 )
	new arg[32]
	read_argv (1, arg, 31)
	new player = cmd_target ( id, arg, 5 ) 
	if ( !player ) return PLUGIN_HANDLED
	
	new ids[2] 
	ids[0] = player 
	get_user_name ( player, victim, 31 )
	new origin[3], position[3]
	get_user_origin ( player, origin )
	
	new r = random(256) 
	new g = random(256) 
	new b = random(256)
	new effect[32]
	read_argv ( 2, effect, 31 )

	if ( effect[0] == '1' ) 
	{
		
		position[0] = origin[0] + 150 
		position[1] = origin[1] + 200
		position[2] = origin[2] + 350
		ThunderClap ( origin, position )
		bloodeffects ( origin )
		Sparks ( origin )
		Smoke ( origin )
		
		client_cmd ( 0, "spk ambience/thunder_clap.wav" )
		client_cmd ( 0, "spk debris/zap6.wav" )
		user_kill ( player )
		
		switch ( get_cvar_num( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Tslayed %s.", admin, victim )
				console_print ( 0, "[AIOS] Admin %s: has Tslayed %s.", admin, victim )
			}
			
			case 1:
			{
				set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has Tslayed %s.", victim )
				console_print ( 0, "[AIOS] Admin : has Tslayed %s.", victim )
			}
		}
	}
	else if ( effect[0] == '2' ) 
	{
		bloodeffects ( origin )
		Gibs ( origin )
		user_kill ( player )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2: 
			{
				set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has bled %s to death.", admin, victim )
				console_print ( 0, "[AIOS] Admin %s: has bled %s to death.", admin, victim )
			}
			
			case 1:
			{
				set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has bled %s to death.", victim )
				console_print ( 0, "[AIOS] Admin : has bled %s to death.", victim )
			}
		}
	}
	else if ( effect[0] == '3' ) 
	{
		origin[2] = origin[2] - 25
		explosion ( origin )
		bloodeffects ( origin )
		user_kill ( player )
		
		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2: 
			{
				set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Exploded %s.", admin, victim )
				console_print ( 0, "[AIOS] Admin %s: has Exploded %s.", admin, victim )
			}
			
			case 1:
			{
				set_hudmessage(  r, g, b, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has Exploded %s.", victim )
				console_print ( 0, "[AIOS] Admin : has Exploded %s.", victim )
			}
		}
	}
	
	else if ( effect[0] != '1' || effect[0] != '2' || effect[0] != '3' ) 
	{
		console_print( id, "[AIOS] Usage : amx_tslay | 1 = Thunder Clap | 2 = Blood\Gibs | 3 = Explosion |" )
	}
	
	return PLUGIN_HANDLED
}

public msSlaps ( id )
{
	if ( get_cvar_num ( "aios_msSlaps" ) != 1 )
	{
		console_print ( id, "[AIOS] Sorry, but this function is turned OFF." )
		return PLUGIN_HANDLED
	}

	new msName[32]
	get_user_name ( id, msName, 31 )

	new argv[32]
	read_argv ( 1, argv, 31 )

	new msNum
	msNum = str_to_num ( argv )

	if ( msNum > 100 ) 
	{
		client_print ( id, print_console, "[AIOS] You cannot slap yourself more than 100 times." )
		return PLUGIN_HANDLED
	}
 
	new MAX_SLAPS = get_cvar_num ( "aios_msLimit" )
	if ( g_msSlaps[id] >= MAX_SLAPS )
	{
		client_print ( id, print_console, "[AIOS] Sorry but you have slapped yourself too many times this round." )
		return PLUGIN_HANDLED
	}
	

	new msID[1]
	msID[0] = id
	g_msSlaps[id]++
	
	set_task ( 0.1, "msSlapEvent", id, "", 0, "a", msNum )

	new r = random ( 256 )
	new g = random ( 256 )
	new b = random ( 256 )

	set_hudmessage ( r, g, b, 0.03, 0.62, 2, 0.02, 7.0, 0.01, 0.1, 1 )
	show_hudmessage ( 0, "[AIOS] %s : Has slapped himself %d time(s)", msName, msNum )
	
	return PLUGIN_CONTINUE
}

public msSlapEvent ( id )
{
	new msDmg = get_cvar_num ( "aios_slapdmg" )
	new Health = get_user_health ( id )
	if ( Health > 1 ) {
		user_slap ( id, msDmg )
	} else if ( Health == 1 ) {
		user_slap ( id, 0 )
	}
	
	return PLUGIN_CONTINUE
}

public msSlapToggle ( id, level, cid )
{
	if ( !cmd_access ( id, level, cid, 2 ) ) {
		return PLUGIN_HANDLED
	}
	
	new arg[5]
	read_argv ( 1, arg, 4 )
	if ( arg[0] == '1' )
	{
		set_cvar_num ( "aios_msSlaps", 1 )
		console_print ( id, "[AIOS] msSlaps has been turned ON." )
	}
	else if ( arg[0] == '0' )
	{
		set_cvar_num ( "aios_msSlaps", 0 )
		console_print ( id, "[AIOS] msSlaps has been turned OFF." )
	}
	else if ( arg[0] != '1' || arg[0] != '0' ) {
		console_print ( id, "[AIOS] Usage : amx_msSlaps : | 1 = ON | 2 = OFF | ")
		return PLUGIN_HANDLED
	}
	
	return PLUGIN_HANDLED
}

public msLimitToggle ( id, level, cid )
{
	if ( !cmd_access ( id, level, cid, 2 ) ) {
		return PLUGIN_HANDLED
	}
	
	new arg[5]
	read_argv ( 1, arg, 4 )
	new num
	num = str_to_num ( arg )
	if ( num > 10 || num < 1 ) {
		console_print ( id, "[AIOS] msLimit must range between 1 - 10" )
		return PLUGIN_HANDLED
	}
	
	set_cvar_num ( "aios_msLimit", num )
	console_print ( id, "[AIOS] msLimit set to %d", num )
	return PLUGIN_HANDLED
}

public SlapMe ( id ) 
{
	if ( get_cvar_num ( "aios_slaps" ) != 1 )
	{
		console_print ( id, "[AIOS] Sorry, but this function is turned OFF." )
		return PLUGIN_HANDLED
	}
	
	new Name[32]
	get_user_name ( id, Name, 31 )

	new argv[32]
	read_argv ( 1, argv, 31 )
	
	new SLAPS = get_cvar_num ( "aios_sLimit" )
	if ( g_msSlaps[id] >= SLAPS )
	{
		console_print ( id, "[AIOS] Sorry but you have slapped yourself too many times this round." )
		return PLUGIN_HANDLED
	}
	
	g_slaps[id]++
	set_task ( 0.1, "User_Slaps", id )
	client_print ( id, print_chat, "[AIOS] %s has slapped himself", Name )
	
	return PLUGIN_HANDLED
}
		
public User_Slaps ( id ) 
{
	new health  = get_user_health ( id )

	if ( health > 1 ) 
	{
		new dmg = get_cvar_num ( "aios_slapdmg" )
		user_slap ( id, dmg )
	} 
	else if ( health <= 1 ) 
	{
		user_slap ( id, 0 )
	}

	return PLUGIN_HANDLED
}

public SlapDmg( id, level, cid )
{
	if ( !cmd_access ( id, level, cid ,2 ) ) {
		return PLUGIN_HANDLED 
	}

	new arg[8] 
	read_argv ( 1, arg,7 ) 

	if ( ( str_to_num ( arg ) > 10 ) || ( str_to_num( arg ) < 0 ) ) 
	{ 
		console_print ( id, "[AIOS] Slap damage must range between 0 - 10." )           
		return PLUGIN_HANDLED 
	} 

	set_cvar_string ("aios_slapdmg", arg )
	new arg_str
	arg_str = str_to_num ( arg )
	console_print ( id, "[AIOS] Slap damage set to %d", arg_str )
	return PLUGIN_HANDLED      
}    

public SlapNum( id, level, cid ) 
{
	if ( !cmd_access ( id, level, cid, 2 )) {
        	return PLUGIN_HANDLED
    	}

    	new arg[8] 
    	read_argv (1, arg, 7 ) 

    	if ( ( str_to_num ( arg ) > 1000) || ( str_to_num ( arg ) < 1 ) )
    	{ 
	    	console_print( id, "[AIOS] The number of slaps must range from between 1 - 1000." ) 
	    	return PLUGIN_HANDLED
    	}
 
    	set_cvar_string ( "aios_slapnum", arg )
	new arg_str
	arg_str = str_to_num ( arg )
    	console_print ( id, "[AIOS] Slap Amount set to %d", arg_str )
    	return PLUGIN_HANDLED      
} 

public SlayAll ( ) 
{
	new slaytargets[32], etotalplayers;
	get_players ( slaytargets, etotalplayers, "a" )

	for ( new e = 0; e < etotalplayers; e++ )
	{
		new id = slaytargets[e]
		user_kill ( id )
 	}
}

public SlayCTs() 
{
	new slaytargets[32], etotalct;
	get_players ( slaytargets, etotalct, "ae", "CT" )

	for ( new e = 0; e < etotalct; e++ )
	{
		new id = slaytargets[e]
		user_kill ( id )
	}
}

public SlayTs ( ) 
{
	new slaytargets[32], etotalt;
	get_players( slaytargets, etotalt, "ae", "TERRORIST" )
	
	for ( new e = 0; e < etotalt; e++ )
	{
		new id = slaytargets[e]
		user_kill ( id )
 	}
}  

public AIOS (id ,level, cid ) 
{
	if (! cmd_access ( id, level, cid, 2 ) ) {
		return PLUGIN_HANDLED
	}

	new aios[32]
	new admin[32]
	get_user_name ( id, admin, 31 )
	read_argv ( 1, aios, 31 )
	
	new r = random(256) 
	new g = random(256) 
	new b = random(256)
	new amount = get_cvar_num ( "aios_slapnum" )

	new Players[32], iTotalPlayers
	get_players( Players, iTotalPlayers, "a" )
		
	if ( aios[0] == '1' ) 
	{
		set_task ( 0.1, "SlapAll", 0, "", 0, "a", amount )

		switch (get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slapped everyone in the server %d time(s).", admin, amount )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slapped everyone in the server %d time(s).", admin, amount )
				console_print ( 0, "[AIOS] Admin %s: has Slapped everyone in the server %d time(s).", admin, amount )
			}
			case 1:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
				show_hudmessage ( 0, "[AIOS] Admin : has Slapped everyone in the server %d time(s).", amount )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slapped everyone in the server %d time(s).", amount )
				console_print ( 0, "[AIOS] Admin : has Slapped everyone in the server %d time(s).", amount )
			}
		}
	} 
	else if ( aios[0] == '2' ) 
	{
		set_task ( 0.1, "SlapCTs", 0, "", 0, "a", amount )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slapped all CTs in the server %d time(s).", admin, amount )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slapped all CTs in the server %d time(s).", admin, amount )
				console_print ( 0, "[AIOS] Admin %s: has Slapped all CTs in the server %d time(s).", admin, amount )
			}
			case 1:
			{
				set_hudmessage (  r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
				show_hudmessage ( 0, "[AIOS] Admin : has Slapped all CTs in the server %d time(s).", amount )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slapped all CTs in the server %d time(s).", amount )
				console_print ( 0, "[AIOS] Admin : has Slapped all CTs in the server %d time(s).", amount )
			}
		}
	} 
	else if ( aios[0] == '3' ) 
	{
		set_task ( 0.1, "SlapTs", 0, "", 0, "a", amount )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slapped all Ts in the server %d time(s).", admin, amount )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slapped all Ts in the server %d time(s).", admin, amount )
				console_print ( 0, "[AIOS] Admin %s: has Slapped all Ts in the server %d time(s).", admin, amount )
			}
			case 1:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
				show_hudmessage ( 0, "[AIOS] Admin : has Slapped all Ts in the server %d time(s).", amount )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slapped all Ts in the server %d time(s).", amount )
				console_print ( 0, "[AIOS] Admin %s: has Slapped all Ts in the server %d time(s).", amount )
			}
		}
	} 
	else if ( aios[0] != '1' || aios[0] != '2' || aios[0] != '3' )
	{
		 console_print ( id, "[AIOS] Usage: amx_aios | 1 = Slap All | 2 = Slap CTs | 3 = Slap Ts |")
	}
	return PLUGIN_HANDLED
}

public AIOS2 ( id ,level, cid ) 
{
	if ( !cmd_access (id, level, cid, 2 ) ) {
		return PLUGIN_HANDLED
	}

	new aios2[32]
	new admin[32]
	get_user_name ( id, admin, 31 )
	read_argv ( 1, aios2, 31 )

	new r = random(256) 
	new g = random(256) 
	new b = random(256)
	if ( aios2[0] == '1' ) 
	{
		set_task ( 0.1, "SlayAll" )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slain everyone in the server.", admin )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slain everyone in the server.", admin )
				console_print ( 0, "[AIOS] Admin %s: has Slain everyone in the server.", admin )
			}
			case 1:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has Slain everyone in the server." )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slain everyone in the server." )
				console_print ( 0, "[AIOS] Admin : has Slain everyone in the server." )
			}
		}
	} 
	else if ( aios2[0] == '2' ) 
	{
		set_task ( 0.1, "SlayCTs" )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slain all CTs in the server.", admin )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slain all CTS in the server.", admin )
				console_print ( 0, "[AIOS] Admin %s: has Slain all CTs in the server.", admin )
			}
			case 1:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has Slain all CTs in the server." )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slain all CTs in the server." )
				console_print ( 0, "[AIOS] Admin : has Slain all CTs in the server." )
			}
		}
	} 
	else if ( aios2[0] == '3' ) 
	{
		set_task ( 0.1, "SlayTs" )

		switch ( get_cvar_num ( "amx_show_activity" ) ) 
		{
			case 2:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin %s: has Slain all Ts in the server.", admin )
				client_print ( 0, print_chat, "[AIOS] Admin %s: has Slain all Ts in the server.", admin )
				console_print ( 0, "[AIOS] Admin %s: has Slain all Ts in the server.", admin )
			}
			case 1:
			{
				set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
				show_hudmessage ( 0, "[AIOS] Admin : has Slain all Ts in the server." )
				client_print ( 0, print_chat, "[AIOS] Admin : has Slain all Ts in the server." )
				console_print ( 0, "[AIOS] Admin %s: has Slain all Ts in the server." )
			}
		}
	} 
	else if ( aios2[0] != '1' || aios2[0] != '2' || aios2[0] != '3' )
	{
		 console_print ( id, "[AIOS] Usage: amx_aios2 | 1 = Slay All | 2 = Slay CTs | 3 = Slay Ts |" )
	}
	return PLUGIN_HANDLED
}
		 
public Point_Slap ( id, level, cid ) 
{
	if ( !cmd_access ( id, level, cid, 1 ) ) {
		return PLUGIN_HANDLED
	}
	
	new target[32], body, x
	get_user_aiming( id, x, body )                                                                                                                                                                        
	get_user_name (x, target, 31 )
	
	new player = find_player( "a", target )
	new damage = get_cvar_num ( "aios_slapdmg" )
	
	new orig[3]
	get_user_origin ( id, orig )
	
	if ( player ) 
	{
		bloodeffects ( orig )
		user_slap( player, damage )
		client_print( id, print_chat, "[AIOS] You have Slapped %s", player )
	} 
	else if ( !player ) 
	{
		client_print( id, print_chat, "[AIOS] Cannot Slap. You are not pointing at anyone.")
	}

	return PLUGIN_HANDLED
}

public Point_Slay ( id, level, cid ) 
{
	if ( !cmd_access ( id, level, cid, 1 ) ) {
		return PLUGIN_HANDLED
	}
	
	new target[32], body, x
	get_user_aiming( id, x, body )
	get_user_name( x, target, 31 )
	
	new orig[3], position[3]
	get_user_origin ( id, orig )
	
	new player = find_player ("a", target )
	if ( player ) 
	{
		position[0] = orig[0] + 150 
		position[1] = orig[1] + 200
		position[2] = orig[2] + 350
		ThunderClap ( orig, position )
		bloodeffects ( orig )
		Sparks ( orig )
		Smoke ( orig )
		user_kill ( player )
		client_print( id, print_chat, "[AIOS] You have Slain %s.", player )
	} 
	else if ( !player ) 
	{
		client_print( id, print_chat, "[AIOS] Cannot Slay. You are not pointing at anyone.")
	}

	return PLUGIN_HANDLED
}

public AiosMotd ( id )
{
	new Aioslen[712]
	new aLen = format ( Aioslen, 711, "<body bgcolor=^"#000000^"><font color=^"#FFFFFF^">" )
	
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_aios     :  < Usage: amx_aios | 1 = Slap All | 2 = Slap CTs | 3 = Slap Ts > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_aios2    :  < Usage: amx_aios2 | 1 = Slay All | 2 = Slay CTs | 3 = Slay Ts > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_tslap    :  < name or userid > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_tslay    :  < name or userid > < Effect 1|2|3 > <br>" ) 
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_slapdmg  :  < Damager per Slap > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_slapnum  :  < Amount of slaps > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "amx_aiosmenu :  < Displays AIOs menu > <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "<br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "Bind a key to /aiosmenu <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "Bind a key to /slap <br>" )
	aLen += format ( Aioslen[aLen], 711 - aLen, "Bind a key to /slay <br>" )
	
	show_motd ( id, Aioslen, "AIOS Commands\Binds" )
	return PLUGIN_HANDLED
}

public AiosMotdCall ( id, level, cid )
{
	if ( !cmd_access ( id, level, cid, 1 ) ) {
		return PLUGIN_HANDLED
	}
	
	set_task ( 1.0, "AiosMotd", id )
	
	return PLUGIN_HANDLED
}

public showMenu ( id, level, cid )
{ 
    if ( !cmd_access ( id, level, cid, 1 ) ) {
        return PLUGIN_HANDLED 
    }
    
    new MenuBody[512] 
    new keys
    new mLen = format ( MenuBody, 511, "\r[\wA\yI\rO\wS\y] \yMenu: NG^nAll.In.One.Slap Menu^nBy \rN\wi\yk\ro \yGlistak^n" )

    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\w1. Slap All" )
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\w2. Slap All CTs" )
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\w3. Slap All Ts^n" )
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\r4. Slay All" ) 
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\r5. Slay All CTs" )
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\r6. Slay All Ts^n" )
    mLen += format ( MenuBody[mLen], 511 - mLen, "^n\y7. Exit Menu" )

    keys = ( 1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6 )
    show_menu ( id, keys, MenuBody, -1 )
    return PLUGIN_HANDLED 
}	
	
public MenuCommand ( id, key ) 
{
	new r = random(256) 
	new g = random(256) 
	new b = random(256)
	new amount = get_cvar_num ( "aios_slapnum" )
	
	switch ( key ) 
	{
		case 0: 
		{
			set_task ( 0.1, "SlapAll", 0, "", 0, "a", amount )
			client_cmd ( 0,"spk barney/ba_tomb" )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 ) 
			show_hudmessage ( 0, "[AIOS] All Players Have Been Slapped!!!" )
			console_print ( 0," [AIOS] All players have been slapped %d times", amount )
			client_print ( 0, print_chat,"[AIOS] All players have been slapped %d times", amount ) 
			set_task ( 1.0, "showMenu", id)
		}

		case 1:
		{
			set_task ( 0.1, "SlapCTs", 0, "", 0, "a", amount )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
			show_hudmessage ( 0, "[AIOS] All CT Players Have Been Slapped!!!" )
			client_cmd ( 0, "spk barney/ba_tomb")
			console_print ( 0, "[AIOS] All CT players have been slapped %d times", amount )
			client_print ( 0, print_chat,"[AIOS] All players on CT team have been slapped %d times", amount ) 
			set_task ( 1.0, "showMenu", id )
		}

		case 2:
		{
			set_task ( 0.1, "SlapTs", 0, "", 0, "a", amount )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
			show_hudmessage ( 0, "[AIOS] All T Players Have Been Slapped!!!" )
			client_cmd ( 0, "spk barney/ba_dontmake")
			console_print ( 0, "[AIOS] All T players have been slapped %d times", amount )
			client_print ( 0, print_chat,"[AIOS] All players on T team have been slapped %d times", amount )
			set_task ( 1.0, "showMenu", id )
   		}

		case 3:
		{
			set_task ( 0.1, "SlayAll" )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 ) 
			show_hudmessage ( 0, "[AIOS] All players SLAYED!" )
			console_print ( 0, "[AIOS] All players SLAYED" )
			client_print ( 0,print_chat,"[AIOS] All have been SLAYED" )
			set_task ( 1.0, "showMenu", id )
		}
		
		case 4:
		{
			set_task ( 0.1, "SlayCTs" )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 ) 
			show_hudmessage ( 0, "[AIOS] All CT players SLAYED!" )
			console_print ( 0, "[AIOS] All CT players SLAYED" )
			client_print ( 0, print_chat,"[AIOS] All CT have been SLAYED" )
			set_task ( 1.0, "showMenu", id)
		} 
		
		case 5:
		{
			set_task ( 0.1, "SlayTs" )
			set_hudmessage ( r ,g ,b ,0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1 )
			show_hudmessage ( 0, "[AIOS] All T players SLAYED!" )
			console_print ( 0, "[AIOS] All T players SLAYED" )
			client_print ( 0, print_chat,"[AIOS] All T have been SLAYED" )
			set_task ( 1.0, "showMenu", id )
   		} 
   		
   		case 6:
   		{
			client_print ( id, print_chat, "[AIOS] Menu Closed." )
   		} 
  	}
	return PLUGIN_HANDLED
}

ThunderClap ( vector1[3], vector2[3] ) 
{
	message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte ( 0 )
	write_coord ( vector1[0] )
	write_coord ( vector1[1] )
	write_coord ( vector1[2] )
	write_coord ( vector2[0] )
	write_coord ( vector2[1] )
	write_coord ( vector2[2] )
	write_short ( lightning )
	write_byte ( 1 )
	write_byte ( 5 )
	write_byte ( 2 ) 
	write_byte ( 20 )
	write_byte ( 30 )
	write_byte ( random(256) )
	write_byte ( random(256) )
	write_byte ( random(256) )
	write_byte ( 200 )
	write_byte ( 150 )
	message_end ( )
}

Sparks ( vector[3] ) 
{
	
	message_begin ( MSG_BROADCAST, SVC_TEMPENTITY, vector )
	write_byte ( 9 )
	write_coord ( vector[0] )
	write_coord ( vector[1] )
	write_coord ( vector[2] )
	message_end ( )
}
 
Smoke ( vector[3] ) 
{  
	message_begin ( MSG_BROADCAST, SVC_TEMPENTITY, vector )
	write_byte ( 5 )
	write_coord ( vector[0] )
	write_coord ( vector[1] )
	write_coord ( vector[2] )
	write_short ( smoke )
	write_byte ( 10 )
	write_byte ( 10 )
	message_end ( )
}

explosion ( vector[3] ) 
{
   message_begin( MSG_BROADCAST, SVC_TEMPENTITY, vector) 
   write_byte ( 3 ) 
   write_coord ( vector[0] ) 
   write_coord ( vector[1] ) 
   write_coord ( vector[2] )
   write_short ( explode ) 
   write_byte ( 188 )
   write_byte ( 10 )
   write_byte ( 0 )
   message_end() 
   
   message_begin ( MSG_BROADCAST, SVC_TEMPENTITY, vector )
   write_byte ( 9 )
   write_coord ( vector[0] )
   write_coord ( vector[1] )
   write_coord ( vector[2] )
   message_end ( )
   
   message_begin ( MSG_BROADCAST, SVC_TEMPENTITY, vector )
   write_byte ( 5 )
   write_coord ( vector[0] )
   write_coord ( vector[1] )
   write_coord ( vector[2] )
   write_short ( smoke )
   write_byte ( 10 )
   write_byte ( 10 )
   message_end ( )
} 

bloodeffects( vec1[3] ) 
{
	message_begin ( MSG_BROADCAST, SVC_TEMPENTITY, vec1 ) 
	write_byte ( 115 )
	write_coord ( vec1[0] ) 
	write_coord ( vec1[1] ) 
	write_coord ( vec1[2] + 25 ) 
	write_short ( bloodspray ) 
	write_short ( blooddrip ) 
	write_byte ( 75 )  
	write_byte ( 20 ) 
	message_end ( ) 
}

Gibs ( orig[3] ) 
{
	// Skull
	message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte ( 106 )
	write_coord ( orig[0] )
	write_coord ( orig[1] )
	write_coord ( orig[2] )
	write_coord ( random ( 50 ) )
	write_coord ( random ( -100 ) )
	write_coord ( random ( 100 ) )
	write_angle ( random ( 360 ) )
	write_short ( gib_skull )
	write_byte ( 0 )
	write_byte ( 750 )
	message_end ()
	
	// Legbone
	for ( new x = 0; x < 2; x++ )
	{
		message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
		write_byte ( 106 )
		write_coord ( orig[0] )
		write_coord ( orig[1] )
		write_coord ( orig[2] )
		write_coord ( random ( 50 ) )
		write_coord ( random ( -100 ) )
		write_coord ( random ( 100 ) )
		write_angle ( random ( 360 ) )
		write_short ( gib_legbone )
		write_byte ( 0 )
		write_byte ( 750 )
		message_end ()
	}
	
	// Lung
	for ( new i = 0; i < random_num ( 1, 2 ); i++ )
	{
		message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
		write_byte ( 106 )
		write_coord ( orig[0] )
		write_coord ( orig[1] )
		write_coord ( orig[2] )
		write_coord ( random ( 50 ) )
		write_coord ( random ( -100 ) )
		write_coord ( random ( 100 ) )
		write_angle ( random ( 360 ) )
		write_short ( gib_lung )
		write_byte ( 0 )
		write_byte ( 750 )
		message_end ()
	}
	
	// Bone
	for ( new v = 0; v < random_num ( 1, 2 ); v++ )
	{
		message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
		write_byte ( 106 )
		write_coord ( orig[0] )
		write_coord ( orig[1] )
		write_coord ( orig[2] )
		write_coord ( random ( 50 ) )
		write_coord ( random ( -100 ) )
		write_coord ( random ( 100 ) )
		write_angle ( random ( 360 ) )
		write_short ( gib_b_bone )
		write_byte ( 0 )
		write_byte ( 750 )
		message_end ()
	}
	
	// Misc
	for ( new n = 0; n < random ( 10 ); n++ ) 
	{
			message_begin ( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte ( 106 )
			write_coord ( orig[0] )
			write_coord ( orig[1] )
			write_coord ( orig[2] )
			write_coord ( random ( 50 ) )
			write_coord ( random ( -100 ) )
			write_coord ( random ( 100 ) )
			write_angle ( random ( 360 ) )
			write_short ( gib_b_gib )
			write_byte ( 0 )
			write_byte ( 750 )
			message_end ()
	}
	
	// Blood
	for ( new y = 0; y < 10; y++ )
	{
			message_begin ( MSG_BROADCAST, SVC_TEMPENTITY ) 
			write_byte ( 115 )
			write_coord ( orig[0] )
			write_coord ( orig[1] )
			write_coord ( orig[2] + 25 ) 
			write_short ( bloodspray ) 
			write_short ( blooddrip ) 
			write_byte ( 75 )  
			write_byte ( 20 ) 
			message_end ( ) 
	}
}